# Component and Services

Component and Service developement is done by making an Angular project where you write your component or service in typescript

On github there is a [NG1 to TiNG example](https://github.com/Servoy/servoyworld_component/tree/ting) that has a "master" branch that just has the NG1 example and the "ting" branch has the TiNG example with some documentation what is what and how to convert.

The specification what a component or service has (properties that can be set, api's that can be called, or events (handlers) that a component can trigger) are defined in a [spec](/reference/extension-dev/component_services/spec-file.md)

What types can be used for the properties on the model of the component or service are described [here](/reference/extension-dev/component_services/spec-file/property_types.md), those properties can have [tags](/reference/extension-dev/component_services/spec-file/property_types/tags.md) to give them a bit more configuration how they are used in developer or at runtime

The [ServoyApi (serverside)](/reference/extension-dev/component_services/servoyapi.md) and [Console](/reference/extension-dev/component_services/console.md) api objects are exposed in server size scripts that components can have.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.servoy.com/reference/extension-dev/component_services.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
